-- Generated by Ora2Pg, the Oracle database Schema converter, version 20.0
-- Copyright 2000-2019 Gilles DAROLD. All rights reserved.
-- DATASOURCE: dbi:Oracle:host=oracle11g;sid=xe;port=1521

SET client_encoding TO 'UTF8';

SET search_path = hr;
\set ON_ERROR_STOP ON



CREATE OR REPLACE FUNCTION hr.add_job_history ( p_emp_id job_history.employee_id%type , p_start_date job_history.start_date%type , p_end_date job_history.end_date%type , p_job_id job_history.job_id%type , p_department_id job_history.department_id%type ) RETURNS VOID AS $body$
BEGIN
  INSERT INTO job_history(employee_id, start_date, end_date,
                           job_id, department_id)
    VALUES (p_emp_id, p_start_date, p_end_date, p_job_id, p_department_id);
END;
$body$
LANGUAGE PLPGSQL
SECURITY DEFINER
;
ALTER FUNCTION add_job_history ( p_emp_id job_history.employee_id%type , p_start_date job_history.start_date%type , p_end_date job_history.end_date%type , p_job_id job_history.job_id%type , p_department_id job_history.department_id%type ) OWNER TO hr;
-- REVOKE ALL ON FUNCTION hr.add_job_history ( p_emp_id job_history.employee_id%type , p_start_date job_history.start_date%type , p_end_date job_history.end_date%type , p_job_id job_history.job_id%type , p_department_id job_history.department_id%type ) FROM PUBLIC;



CREATE OR REPLACE FUNCTION hr.secure_dml () RETURNS VOID AS $body$
BEGIN
  IF TO_CHAR(clock_timestamp(), 'HH24:MI') NOT BETWEEN '08:00' AND '18:00'
        OR TO_CHAR(clock_timestamp(), 'DY') IN ('SAT', 'SUN') THEN
	RAISE EXCEPTION '%', 'You may only make changes during normal office hours' USING ERRCODE = '45205';
  END IF;
END;
$body$
LANGUAGE PLPGSQL
SECURITY DEFINER
;
ALTER FUNCTION secure_dml () OWNER TO hr;
-- REVOKE ALL ON FUNCTION hr.secure_dml () FROM PUBLIC;

